#
# this comment is necessary for vmware
#
# archive.awkb - converts the snmpwalk output to a ServerView archive file. 
#                This file can be importedd in Frontend.
#
BEGIN {
#	Array for converting decimal IP-Adresses in Hexadecimal format
	hconv[0] = "0"
	hconv[1] = "1"
	hconv[2] = "2"
	hconv[3] = "3"
	hconv[4] = "4"
	hconv[5] = "5"
	hconv[6] = "6"
	hconv[7] = "7"
	hconv[8] = "8"
	hconv[9] = "9"
	hconv[10] = "A"
	hconv[11] = "B"
	hconv[12] = "C"
	hconv[13] = "D"
	hconv[14] = "E"
	hconv[15] = "F"
	
	
#	Array of Hex-String Variables which remain in hex format
	while ((getline < parsIni) > 0) 
		parser[$1]="NoPrint"
		
	close (parsIni)
# for testing the Array contents
#	for (parsoid in parser)
#		printf("%s  |  %s\n", parsoid, parser[parsoid])

#	Build the Array to convert Hex Notation to Caracters
#       eg. "20" " "
#           "21" "!"
#              .
#              .
#           "30" "0"
#           "31" "1"
#              .
#              .
#           "7E" "~"
	ascitab[2] = " !\"#$%&'()*+,-./"
	ascitab[3] = "0123456789:;<=>?"
	ascitab[4] = "@ABCDEFGHIJKLMNO"
	ascitab[5] = "PQRSTUVWXYZ[\\]^_"
	ascitab[6] = "`abcdefghijklmno"
	ascitab[7] = "pqrstuvwxyz{|}~."
	
	for (lo = 2; lo <= 7; lo++) {
		for (ho = 0; ho <= 15; ho++) {
			hexval = sprintf("%s%s", lo, hconv[ho])
			asciChar = substr(ascitab[lo], ho + 1, 1)
			HexToAsci[hexval] = asciChar
		}
	}
	HexToAsci["C4"] = ""
	HexToAsci["D6"] = ""
	HexToAsci["DC"] = ""
	HexToAsci["E4"] = ""
	HexToAsci["F6"] = ""
	HexToAsci["FC"] = ""
	HexToAsci["DF"] = ""
	
# for testing the Array contents
#	for (hexWert in HexToAsci)
#		printf("%s  |  %s\n", hexWert, HexToAsci[hexWert])
}

{
#	on Debug print the snmpwalk output as it is
	if (debug) 
		print $0 >> "/tmp/archiveDebug.txt"
		
# print the remaining lines of a Hex-STRING
#	6D 20 53 79 73 74 65 6D 20 30 20 62 65 74 E4 74 
#	69 67 74  ==>  OCTET STRING = Einschalttaste am System 0 bettigt

	if ($1 ~ /^[0-9A-Fa-f][0-9A-Fa-f]/) {
		for (i=1; i <= NF; i++){
			if ($i in HexToAsci)
				printf ("%s", HexToAsci[$i])
			else
				printf ("%s", ".")
		}
	next
	}
	
	if (printEOL)
		printf ("\n")
	printEOL = 0

	
#	eliminate Backslashes
	if (! gsub(/PCI\\\\VEN/,"PCI\\VEN"))
		gsub(/\\/,"")
		
	print "Variable = " substr($1,2)
	
#	Print different types of String Variable
#	STRING: "<<not supported>>"  ==>  OCTET STRING = <<not supported>>
#	STRING: 0:1d:71:ec:50:0  ==>  OCTET STRING = <0x00><0x1D><0x71><0xEC><0x50><0x00>
#	STRING: peth0  ==>  OCTET STRING = peth0
	if ($3 == "STRING:") {
		strng = substr($0,(index($0, $3) + (length($3) + 1)))
		if (pos = index(strng, "\""))
			print "OCTET STRING = " substr(strng, (pos + 1), (length(strng) -pos -1))
		else if (strng ~ /.*:.*:.*:.*:.*:.*/) {
			split (strng, rawOctet, ":")
			for (i in rawOctet) {
				if (length(rawOctet[i]) == 1) 
					fmtOctet[i] = sprintf("%s%s", "0",toupper(rawOctet[i]))
				else 
					fmtOctet[i] = toupper(rawOctet[i])
			}
			printf ("OCTET STRING = <0x%s><0x%s><0x%s><0x%s><0x%s><0x%s>\n", fmtOctet[1], fmtOctet[2], fmtOctet[3],
											 fmtOctet[4], fmtOctet[5], fmtOctet[6])
		}
		else
			print "OCTET STRING = " strng
	}
#	OID: .1.3.6.1.4.1.8072.3.2.10  ==>  OBJECT IDENTIFIER = 1.3.6.1.4.1.8072.3.2.10
	else if ($3 == "OID:")
		print "OBJECT IDENTIFIER = " substr($4, 2)

#	Timeticks: (1117480) 3:06:14.80  ==>  TimeTicks = 1890713
	else if ($3 == "Timeticks:")
		print "TimeTicks = " substr($4,2, (length($4) -2))
		
#	INTEGER: 12  ==>  INTEGER = 12
#	INTEGER: softwareLoopback(24)  ==>  INTEGER = 24
	else if ($3 == "INTEGER:") {
		if (pos = index($4, "("))
			print "INTEGER = " substr($4, (pos + 1), (length($4) -pos -1))
		else
			print "INTEGER = " $4
	}
#	Gauge32: 10000000  ==>  Gauge = 10000000
	else if ($3 == "Gauge32:")
		print "Gauge = " $4
		
#	Counter32: 3475424134  ==>  Counter 3475424134
	else if ($3 == "Counter32:")
		print "Counter = " $4
		
#	IpAddress: 172.25.250.179  ==>  IpAddress = AC19FAB3
	else if ($3 == "IpAddress:") {
		split($4, iparr, ".")
		printf ("IpAddress = %s%s%s%s\n", convHex(iparr[1]), convHex(iparr[2]), convHex(iparr[3]), convHex(iparr[4]))
	}
	
#	Hex-STRING: 00 30 05 58 B9 66  ==>  OCTET STRING = <0x00><0x30><0x05><0x58><0xB9><0x66>
#	Hex-STRING: 45 69 6E 73 63 68 61 6C 74 74 61 73 74 65 20 61 
#	6D 20 53 79 73 74 65 6D 20 30 20 62 65 74 E4 74 
#	69 67 74  ==>  OCTET STRING = Einschalttaste am System 0 bettigt

	else if ($3 == "Hex-STRING:") {
		printf ("OCTET STRING = ")
#		Check if the string should be converted in characters 
		if ((NF - 4) <= 8 || $1 in parser ) {
			for (i=4; i <= NF; i++) 
				printf ("<0x%s>", $i)
			printf ("\n")
		} else {
			for (i=4; i <= NF; i++) {
				if ($i in HexToAsci)
					printf ("%s", HexToAsci[$i])
				else
					
					printf ("%s", ".")
			}
#			print end of line after the last character
			printEOL = 1
		}
	}
	
#	""   ==>  OCTET STRING =
	else if ($3 == "\"\"")
		printf ("OCTET STRING = \n")
#	print as is is
	else
		print substr($0, (index($0, "=") + 1 ))

}		
		
# Convert a decimal number in a Hexadecimal
function convHex (val) {
	hvalL = hconv[int(val / 16)]
	hvalR = hconv[int(val % 16)]
	return (sprintf("%s%s", hvalL, hvalR))
}
