#!/bin/sh
# $Copyright$
# Copyright 2011-2017 FUJITSU LIMITED
# All rights reserved
#
# If your system needs more time to make device data after the hotplug 
# event occured, please delete the "#" of the next line.
#sleep 30

SV_PATH=/usr/sbin/eecd
SUBSYSTEM=$1
DEVPATH=$2
ACTION=$3


#========================================================================
# main()
#
# parameter
#	$1:"pci" or "scsi"
#	$2:"PCI_SLOT_NAME" for pci or "DEVPATH" for scsi
#	$3:action "add" or "remove"
#
# return value
#   0:OK 1:NG
#========================================================================
# check if SVagents are installed and eecd is ready
if [ ! -e $SV_PATH  -o  ! -e /dev/eecda ] ; then
	exit 1
fi

InventoryRescan=120
. /etc/srvmagt/config

if [ $SUBSYSTEM == "pci" ] ; then
	/usr/sbin/eecdcp -c oc=141E oe=0000
	/etc/init.d/srvmagt restart bus
	[ $InventoryRescan -ne 0 ] &&  {
		/usr/sbin/SVforceVV
	}
elif [ $SUBSYSTEM == "scsi" ] ; then
#	if [ $ACTION == "remove" ] ; then
#		sleep 45
#	fi
	/usr/sbin/eecdcp -c oc=141E oe=0000
	[ $InventoryRescan -ne 0 ] &&  {
		/usr/sbin/SVforceVV
	}
else
	exit 1
fi

exit 0

